type Key = string | number | symbol;
export declare function useMap<K extends Key, V extends number>(arr?: [K, V][]): {
    get: (key: K) => unknown;
    set: (key: K, value: V) => void;
    delete: (key: K) => void;
    clear: () => void;
    forEach: (callback: (value: V, key: K, set: Map<K, V>) => void) => void;
    has: (key: K) => boolean;
    entries: () => IterableIterator<[Key, unknown]>;
    values: () => IterableIterator<unknown>;
    keys: () => IterableIterator<Key>;
    size: number;
};
export {};
