import { useReducer } from 'react';
function reducer(state, action) {
    switch (action.type) {
        case 'set': {
            state.map.set(action.key, action.value);
            break;
        }
        case 'delete': {
            state.map.delete(action.key);
            break;
        }
        case 'clear': {
            state.map.clear();
            break;
        }
        default:
            break;
    }
    return {
        map: state.map,
    };
}
export function useMap(arr = []) {
    const [state, dispatch] = useReducer(reducer, arr, (a) => ({
        map: new Map(a),
    }));
    return {
        get: (key) => state.map.get(key),
        set: (key, value) => dispatch({ type: 'set', key, value }),
        delete: (key) => dispatch({ type: 'delete', key }),
        clear: () => dispatch({ type: 'clear' }),
        forEach: (callback) => state.map.forEach(callback),
        has: (key) => state.map.has(key),
        entries: state.map.entries,
        values: state.map.values,
        keys: state.map.keys,
        size: state.map.size,
    };
}
//# sourceMappingURL=useMap.js.map