import { useReducer } from 'react';
function reducer(state, action) {
    switch (action.type) {
        case 'push': {
            state.stack.push(...action.values);
            break;
        }
        case 'pop': {
            state.stack.pop();
            break;
        }
        case 'clear': {
            return { stack: [] };
        }
        default:
            break;
    }
    return {
        stack: state.stack,
    };
}
export function useStack(arr = []) {
    const [state, dispatch] = useReducer(reducer, arr, (a) => ({
        stack: [...(a || [])],
    }));
    return {
        push: (...values) => {
            dispatch({ type: 'push', values });
            return values;
        },
        pop: () => {
            const item = state.stack[state.stack.length - 1] || null;
            dispatch({ type: 'pop' });
            return item;
        },
        clear: () => dispatch({ type: 'clear' }),
        forEach: (callback) => state.set.forEach(callback),
        includes: (value) => state.stack.includes(value),
        peek: () => state.stack[state.stack.length - 1] || null,
        entries: state.stack.entries,
        values: state.stack.values,
        keys: state.stack.keys,
        size: state.stack.length,
    };
}
//# sourceMappingURL=useStack.js.map